/* Line Join Button Box
 *
 * Line join button boxes provide the user with a means of selecting various
 * line join styles. Each button shows a graphical representation of the
 * line join.
 */

#include "gtkmm.h"

#include <papyrusmm/linejoinbuttonbox.h>

class Example_LineJoinButtonBox : public Gtk::Window
{
  public:
    Example_LineJoinButtonBox();
    virtual ~Example_LineJoinButtonBox();

  protected:
  //Member widgets:
    PapyrusGtk::LineJoinButtonBox m_LineJoinButtonBox[5];
    Gtk::Frame m_frame[5];
    Gtk::VBox m_vbox;
};

//Called by DemoWindow;
Gtk::Window* do_LineJoinButtonBox()
{
  return new Example_LineJoinButtonBox();
}

Example_LineJoinButtonBox::Example_LineJoinButtonBox()
{

  set_title("Line Join Button Boxes");
  set_border_width(10);

  this->add( m_vbox );

  m_frame[0].set_label( "Extra Small: " );
  m_LineJoinButtonBox[0].set_size( PapyrusGtk::SIZE_XSMALL );

  m_frame[1].set_label( "Small: " );
  m_LineJoinButtonBox[1].set_size( PapyrusGtk::SIZE_SMALL );

  m_frame[2].set_label( "Medium: " );
  m_LineJoinButtonBox[2].set_size( PapyrusGtk::SIZE_MEDIUM );

  m_frame[3].set_label( "Large: " );
  m_LineJoinButtonBox[3].set_size( PapyrusGtk::SIZE_LARGE );

  m_frame[4].set_label( "Extra Large: " );
  m_LineJoinButtonBox[4].set_size( PapyrusGtk::SIZE_XLARGE );

  for ( int i = 0; i <= 5; i++ ) {
    m_frame[i].add( m_LineJoinButtonBox[i] );
    m_vbox.pack_start( m_frame[i], Gtk::PACK_EXPAND_WIDGET, 10);
  }

  m_vbox.set_border_width(10);

  show_all();
}

Example_LineJoinButtonBox::~Example_LineJoinButtonBox()
{
}
