/* Gdk Pixbufs from a Papyrus Canvas
 *
 * It's easy ( a one line function call ) to render a Papyrus Canvas or any
 * other drawing that inherits from Papyrus::Renderable into a Gdk Pixbuf.
 * This example shows how.
 */

#include "gtkmm.h"

#include <papyrus/canvas.h>
#include <papyrus/factory.h>
#include <papyrusmm/utility.h>

class Example_Pixbuf : public Gtk::Window
{
  public:
    Example_Pixbuf();
    virtual ~Example_Pixbuf();

  protected:
  //Member widgets:
    Gtk::Image m_GtkImage;
};

//Called by DemoWindow;
Gtk::Window* do_Pixbuf()
{
  return new Example_Pixbuf();
}

Example_Pixbuf::Example_Pixbuf()
{
  set_title("Pixbuf from Papyrus Canvas Example");
  set_border_width(10);

  Papyrus::Canvas::pointer canvas = Papyrus::Canvas::create();
  canvas->set_translate(100,100);
  canvas->add( Papyrus::example_group( true, false ) );

  Glib::RefPtr<Gdk::Pixbuf> pixbuf;
  // This is the real line of interest
  // Creating a Gdk::Pixbuf from a Papyrus::Canvas
  // But, any Papyrus::Renderable will work
  pixbuf = PapyrusGtk::create_pixbuf(canvas, 200, 200);

  m_GtkImage.set( pixbuf );
  this->add( m_GtkImage );
  this->modify_bg( Gtk::STATE_NORMAL, Gdk::Color("black") );
  this->show_all();
}

Example_Pixbuf::~Example_Pixbuf()
{
}
